#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK24x24x24NT0x0x0_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=24, NB=24, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 24;
   const float *stN = B + 24;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 4 - (((lda) << 4)+((lda) << 3)), incAn = -24;
   const int incBk = (ldb), incBm = -(((ldb) << 4)+((ldb) << 3));
   #define incBn 1
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (ldc) - 24;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         ATL_pfl1W(pC0);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         m1 = rA1 * rB0;
         rA3 = pA0[3];
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         m5 = rA1 * rB0;
         m6 = rA2 * rB0;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 = m1;
         m1 = rA1 * rB0;
         rC2_0 = m2;
         m2 = rA2 * rB0;
         rC3_0 = m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rA3 = pA0[3];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rC0_0 += m0;
         rC1_0 += m1;
         rC2_0 += m2;
         rC3_0 += m3;
         rC0_0 += m4;
         rC1_0 += m5;
         rC2_0 += m6;
         rC3_0 += m7;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC1_0 *= rB0;
         rC2_0 *= rB0;
         rC3_0 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
