#define ATL_USERMM ATL_dJIK54x54x54TN54x54x0_a1_bX
#define ATL_USERMM_b1 ATL_dJIK54x54x54TN54x54x0_a1_b1
#define ATL_USERMM_bn1 ATL_dJIK54x54x54TN54x54x0_a1_bn1
#define ATL_USERMM_b0 ATL_dJIK54x54x54TN54x54x0_a1_b0
#define ATL_USERMM_bX ATL_dJIK54x54x54TN54x54x0_a1_bX
#define BETAX
#define DREAL

#define MB 54
#define NB 54
#define KB 54

#define MBMB 2916
#define NBNB 2916
#define KBKB 2916

#define MB2 108
#define NB2 108
#define KB2 108


#define MB3 162
#define NB3 162
#define KB3 162


#define MB4 216
#define NB4 216
#define KB4 216


#define MB5 270
#define NB5 270
#define KB5 270


#define MB6 324
#define NB6 324
#define KB6 324


#define MB7 378
#define NB7 378
#define KB7 378


#define MB8 432
#define NB8 432
#define KB8 432

#ifdef BETA0
#define ATL_INT int
#include <stdio.h>
#include <stdint.h>
#include <pmmintrin.h>

#define I_UNROLL 6
#define J_UNROLL 1
/* Is prefetched data written or just read? */
#define PF_READONLY 0
#define PF_READWRITE 1
#define PF_NO_REUSE 0

/* Default temporality of cache prefetch (1-3) */
#define PF_DEF 1
#define CACHE_LINE_SIZE 64
#define MMCAST( a ) (float*)(a)
#define MMCASTStore( a ) (float*)(a)
#define MMCASTStoreintrin( a ) (__m128)(a)
#define TYPE double
void ATL_USERMM( const ATL_INT M, const ATL_INT N, const ATL_INT K,
                 const TYPE alpha, const TYPE *A, const ATL_INT lda,
                 const TYPE *B, const ATL_INT ldb,
                 const TYPE beta, TYPE *C, const ATL_INT ldc )
{
   register ATL_INT i, j, k;
   
   /* Vector registers to hold the elements of C */
   __m128d c0_0, c0_1, c0_2, c0_3, c0_4, c0_5;
   /* Temporary vector registers for use in inner loop */
   __m128d temp; 
   /* Pointer adjustments */  
   register const ATL_INT ldc_bytes = ldc;
   
   register TYPE const *B0_off = B;
      
   register void const * prefetchABlock =  (void*)(A + 54*KB); 
   
   /* Unroll A */
   __m128d A0, a0, A1, a1, A2, a2, A3, a3, A4, a4, A5, a5;
   /* Unroll B */
   __m128d B0, B1;
   

   register const ATL_INT unroll_a = I_UNROLL*KB;
   register TYPE* cPtr = C;
   

   const ATL_INT pfBlockDistance = (6 * 1 * KB * 8) / 54;
   /* =======================================
    * Begin generated inner loops for case Non aligned
    * ======================================= */
   for( j=-54; j!=0; j+=J_UNROLL) 
   {
      register TYPE const *A0_off = A; 
      
      register TYPE *cPtrI0 = cPtr;
      

      for( i=-54; i != 0; i+= I_UNROLL )
      {
         /* K_Unrolling0 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 54) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 108) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 162) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 216) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 270) );
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off) );
         c0_0 = B0;
         c0_0 = _mm_mul_pd( A0, c0_0 );
         c0_1 = B0;
         c0_1 = _mm_mul_pd( A1, c0_1 );
         c0_2 = B0;
         c0_2 = _mm_mul_pd( A2, c0_2 );
         c0_3 = B0;
         c0_3 = _mm_mul_pd( A3, c0_3 );
         c0_4 = B0;
         c0_4 = _mm_mul_pd( A4, c0_4 );
         c0_5 = B0;
         c0_5 = _mm_mul_pd( A5, c0_5 );
         
         /* Prefetch one element from the next block of A */
         __builtin_prefetch( prefetchABlock + 0*pfBlockDistance,PF_READONLY, PF_DEF );
         /* K_Unrolling: 2 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 2) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 56) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 110) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 164) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 218) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 272) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 2) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 4 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 4) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 58) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 112) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 166) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 220) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 274) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 4) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 6 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 6) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 60) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 114) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 168) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 222) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 276) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 6) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 8 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 8) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 62) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 116) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 170) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 224) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 278) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 8) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 10 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 10) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 64) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 118) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 172) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 226) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 280) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 10) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 12 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 12) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 66) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 120) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 174) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 228) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 282) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 12) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 14 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 14) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 68) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 122) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 176) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 230) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 284) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 14) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 16 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 16) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 70) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 124) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 178) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 232) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 286) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 16) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 18 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 18) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 72) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 126) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 180) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 234) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 288) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 18) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 20 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 20) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 74) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 128) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 182) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 236) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 290) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 20) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 22 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 22) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 76) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 130) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 184) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 238) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 292) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 22) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 24 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 24) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 78) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 132) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 186) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 240) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 294) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 24) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 26 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 26) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 80) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 134) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 188) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 242) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 296) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 26) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 28 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 28) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 82) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 136) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 190) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 244) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 298) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 28) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 30 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 30) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 84) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 138) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 192) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 246) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 300) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 30) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 32 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 32) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 86) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 140) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 194) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 248) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 302) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 32) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 34 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 34) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 88) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 142) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 196) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 250) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 304) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 34) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 36 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 36) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 90) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 144) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 198) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 252) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 306) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 36) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 38 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 38) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 92) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 146) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 200) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 254) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 308) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 38) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 40 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 40) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 94) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 148) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 202) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 256) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 310) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 40) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 42 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 42) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 96) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 150) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 204) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 258) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 312) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 42) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 44 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 44) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 98) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 152) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 206) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 260) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 314) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 44) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 46 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 46) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 100) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 154) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 208) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 262) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 316) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 46) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 48 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 48) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 102) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 156) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 210) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 264) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 318) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 48) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 50 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 50) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 104) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 158) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 212) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 266) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 320) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 50) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 52 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 52) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 106) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 160) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 214) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 268) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 322) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 52) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         prefetchABlock += 1*pfBlockDistance;
         /* Combine scalar expansion back to scalar */
         c0_0 = _mm_hadd_pd( c0_0, c0_1 );
         c0_2 = _mm_hadd_pd( c0_2, c0_3 );
         c0_4 = _mm_hadd_pd( c0_4, c0_5 );
         /* Applying Beta */
         /* No beta will be appied */
         /* Move pointers to next iteration */  
         A0_off += unroll_a;
         
         /* Store results back to memory  */
         _mm_storeu_ps( MMCAST( cPtrI0 ),  MMCASTStoreintrin( c0_0 ) );
         _mm_storeu_ps( MMCAST( cPtrI0+2 ),  MMCASTStoreintrin( c0_2 ) );
         _mm_storeu_ps( MMCAST( cPtrI0+4 ),  MMCASTStoreintrin( c0_4 ) );
         cPtrI0 += I_UNROLL;
         

      } /* End i/MB loop */

      B0_off += J_UNROLL*KB;
      cPtr += J_UNROLL*ldc_bytes;
   } /* End j/NB loop */
   /* End of generated inner loops */
}
#elif defined(BETAX)
#define ATL_INT int
#include <stdio.h>
#include <stdint.h>
#include <pmmintrin.h>

#define I_UNROLL 6
#define J_UNROLL 1
/* Is prefetched data written or just read? */
#define PF_READONLY 0
#define PF_READWRITE 1
#define PF_NO_REUSE 0

/* Default temporality of cache prefetch (1-3) */
#define PF_DEF 1
#define CACHE_LINE_SIZE 64
#define MMCAST( a ) (float*)(a)
#define MMCASTStore( a ) (float*)(a)
#define MMCASTStoreintrin( a ) (__m128)(a)
#define TYPE double
void ATL_USERMM( const ATL_INT M, const ATL_INT N, const ATL_INT K,
                 const TYPE alpha, const TYPE *A, const ATL_INT lda,
                 const TYPE *B, const ATL_INT ldb,
                 const TYPE beta, TYPE *C, const ATL_INT ldc )
{
   register ATL_INT i, j, k;
   
   /* Vector registers to hold the elements of C */
   __m128d c0_0, c0_1, c0_2, c0_3, c0_4, c0_5;
   /* Vector register to hold C*beta */
   __m128d bc0_0, bc0_2, bc0_4, bc0_5;
   /* Temporary vector registers for use in inner loop */
   __m128d temp; 
   const __m128d betaV = _mm_set1_pd( beta ); 
   /* Pointer adjustments */  
   register const ATL_INT ldc_bytes = ldc;
   
   register TYPE const *B0_off = B;
      
   register void const * prefetchABlock =  (void*)(A + 54*KB); 
   
   /* Unroll A */
   __m128d A0, a0, A1, a1, A2, a2, A3, a3, A4, a4, A5, a5;
   /* Unroll B */
   __m128d B0, B1;
   

   register const ATL_INT unroll_a = I_UNROLL*KB;
   register TYPE* cPtr = C;
   

   const ATL_INT pfBlockDistance = (6 * 1 * KB * 8) / 54;
   /* =======================================
    * Begin generated inner loops for case Non aligned
    * ======================================= */
   for( j=-54; j!=0; j+=J_UNROLL) 
   {
      register TYPE const *A0_off = A; 
      
      register TYPE *cPtrI0 = cPtr;
      

      for( i=-54; i != 0; i+= I_UNROLL )
      {
         /* K_Unrolling0 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 54) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 108) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 162) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 216) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 270) );
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off) );
         c0_0 = B0;
         c0_0 = _mm_mul_pd( A0, c0_0 );
         c0_1 = B0;
         c0_1 = _mm_mul_pd( A1, c0_1 );
         c0_2 = B0;
         c0_2 = _mm_mul_pd( A2, c0_2 );
         c0_3 = B0;
         c0_3 = _mm_mul_pd( A3, c0_3 );
         c0_4 = B0;
         c0_4 = _mm_mul_pd( A4, c0_4 );
         c0_5 = B0;
         c0_5 = _mm_mul_pd( A5, c0_5 );
         
         /* Prefetch one element from the next block of A */
         __builtin_prefetch( prefetchABlock + 0*pfBlockDistance,PF_READONLY, PF_DEF );
         /* K_Unrolling: 2 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 2) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 56) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 110) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 164) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 218) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 272) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 2) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 4 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 4) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 58) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 112) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 166) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 220) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 274) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 4) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 6 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 6) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 60) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 114) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 168) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 222) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 276) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 6) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 8 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 8) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 62) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 116) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 170) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 224) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 278) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 8) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 10 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 10) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 64) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 118) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 172) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 226) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 280) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 10) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 12 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 12) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 66) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 120) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 174) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 228) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 282) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 12) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 14 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 14) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 68) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 122) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 176) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 230) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 284) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 14) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 16 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 16) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 70) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 124) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 178) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 232) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 286) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 16) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 18 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 18) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 72) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 126) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 180) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 234) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 288) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 18) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 20 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 20) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 74) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 128) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 182) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 236) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 290) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 20) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 22 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 22) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 76) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 130) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 184) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 238) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 292) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 22) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 24 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 24) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 78) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 132) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 186) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 240) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 294) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 24) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 26 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 26) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 80) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 134) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 188) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 242) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 296) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 26) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 28 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 28) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 82) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 136) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 190) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 244) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 298) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 28) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 30 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 30) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 84) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 138) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 192) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 246) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 300) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 30) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 32 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 32) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 86) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 140) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 194) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 248) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 302) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 32) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 34 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 34) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 88) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 142) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 196) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 250) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 304) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 34) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 36 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 36) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 90) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 144) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 198) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 252) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 306) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 36) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 38 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 38) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 92) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 146) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 200) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 254) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 308) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 38) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 40 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 40) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 94) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 148) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 202) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 256) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 310) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 40) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 42 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 42) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 96) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 150) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 204) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 258) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 312) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 42) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 44 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 44) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 98) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 152) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 206) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 260) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 314) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 44) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 46 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 46) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 100) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 154) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 208) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 262) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 316) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 46) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 48 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 48) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 102) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 156) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 210) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 264) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 318) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 48) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 50 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 50) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 104) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 158) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 212) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 266) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 320) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 50) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 52 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 52) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 106) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 160) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 214) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 268) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 322) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 52) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         prefetchABlock += 1*pfBlockDistance;
         /* Combine scalar expansion back to scalar */
         c0_0 = _mm_hadd_pd( c0_0, c0_1 );
         c0_2 = _mm_hadd_pd( c0_2, c0_3 );
         c0_4 = _mm_hadd_pd( c0_4, c0_5 );
         /* Applying Beta */
            /* Apply Beta Factor */
            /* Load C from memory */
            bc0_0 = _mm_loadu_pd( cPtrI0+0 );
            bc0_0 = _mm_mul_pd( betaV, bc0_0 );
            bc0_2 = _mm_loadu_pd( cPtrI0+2 );
            bc0_2 = _mm_mul_pd( betaV, bc0_2 );
            bc0_4 = _mm_loadu_pd( cPtrI0+4 );
            bc0_4 = _mm_mul_pd( betaV, bc0_4 );
            /* C = (beta*C) + (matrix multiply) */
            c0_0 = _mm_add_pd( bc0_0, c0_0 );
            c0_2 = _mm_add_pd( bc0_2, c0_2 );
            c0_4 = _mm_add_pd( bc0_4, c0_4 );
         /* Move pointers to next iteration */  
         A0_off += unroll_a;
         
         /* Store results back to memory  */
         _mm_storeu_ps( MMCAST( cPtrI0 ),  MMCASTStoreintrin( c0_0 ) );
         _mm_storeu_ps( MMCAST( cPtrI0+2 ),  MMCASTStoreintrin( c0_2 ) );
         _mm_storeu_ps( MMCAST( cPtrI0+4 ),  MMCASTStoreintrin( c0_4 ) );
         cPtrI0 += I_UNROLL;
         

      } /* End i/MB loop */

      B0_off += J_UNROLL*KB;
      cPtr += J_UNROLL*ldc_bytes;
   } /* End j/NB loop */
   /* End of generated inner loops */
}
#else
#define ATL_INT int
#include <stdio.h>
#include <stdint.h>
#include <pmmintrin.h>

#define I_UNROLL 6
#define J_UNROLL 1
/* Is prefetched data written or just read? */
#define PF_READONLY 0
#define PF_READWRITE 1
#define PF_NO_REUSE 0

/* Default temporality of cache prefetch (1-3) */
#define PF_DEF 1
#define CACHE_LINE_SIZE 64
#define MMCAST( a ) (float*)(a)
#define MMCASTStore( a ) (float*)(a)
#define MMCASTStoreintrin( a ) (__m128)(a)
#define TYPE double
void ATL_USERMM( const ATL_INT M, const ATL_INT N, const ATL_INT K,
                 const TYPE alpha, const TYPE *A, const ATL_INT lda,
                 const TYPE *B, const ATL_INT ldb,
                 const TYPE beta, TYPE *C, const ATL_INT ldc )
{
   register ATL_INT i, j, k;
   
   /* Vector registers to hold the elements of C */
   __m128d c0_0, c0_1, c0_2, c0_3, c0_4, c0_5;
   /* Vector register to hold C*beta */
   __m128d bc0_0, bc0_2, bc0_4, bc0_5;
   /* Temporary vector registers for use in inner loop */
   __m128d temp; 
   /* Pointer adjustments */  
   register const ATL_INT ldc_bytes = ldc;
   
   register TYPE const *B0_off = B;
      
   register void const * prefetchABlock =  (void*)(A + 54*KB); 
   
   /* Unroll A */
   __m128d A0, a0, A1, a1, A2, a2, A3, a3, A4, a4, A5, a5;
   /* Unroll B */
   __m128d B0, B1;
   

   register const ATL_INT unroll_a = I_UNROLL*KB;
   register TYPE* cPtr = C;
   

   const ATL_INT pfBlockDistance = (6 * 1 * KB * 8) / 54;
   /* =======================================
    * Begin generated inner loops for case Non aligned
    * ======================================= */
   for( j=-54; j!=0; j+=J_UNROLL) 
   {
      register TYPE const *A0_off = A; 
      
      register TYPE *cPtrI0 = cPtr;
      

      for( i=-54; i != 0; i+= I_UNROLL )
      {
         /* K_Unrolling0 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 54) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 108) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 162) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 216) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 270) );
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off) );
         c0_0 = B0;
         c0_0 = _mm_mul_pd( A0, c0_0 );
         c0_1 = B0;
         c0_1 = _mm_mul_pd( A1, c0_1 );
         c0_2 = B0;
         c0_2 = _mm_mul_pd( A2, c0_2 );
         c0_3 = B0;
         c0_3 = _mm_mul_pd( A3, c0_3 );
         c0_4 = B0;
         c0_4 = _mm_mul_pd( A4, c0_4 );
         c0_5 = B0;
         c0_5 = _mm_mul_pd( A5, c0_5 );
         
         /* Prefetch one element from the next block of A */
         __builtin_prefetch( prefetchABlock + 0*pfBlockDistance,PF_READONLY, PF_DEF );
         /* K_Unrolling: 2 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 2) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 56) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 110) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 164) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 218) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 272) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 2) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 4 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 4) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 58) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 112) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 166) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 220) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 274) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 4) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 6 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 6) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 60) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 114) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 168) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 222) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 276) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 6) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 8 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 8) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 62) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 116) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 170) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 224) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 278) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 8) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 10 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 10) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 64) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 118) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 172) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 226) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 280) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 10) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 12 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 12) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 66) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 120) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 174) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 228) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 282) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 12) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 14 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 14) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 68) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 122) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 176) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 230) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 284) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 14) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 16 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 16) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 70) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 124) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 178) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 232) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 286) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 16) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 18 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 18) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 72) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 126) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 180) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 234) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 288) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 18) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 20 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 20) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 74) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 128) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 182) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 236) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 290) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 20) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 22 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 22) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 76) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 130) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 184) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 238) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 292) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 22) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 24 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 24) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 78) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 132) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 186) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 240) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 294) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 24) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 26 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 26) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 80) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 134) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 188) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 242) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 296) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 26) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 28 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 28) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 82) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 136) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 190) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 244) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 298) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 28) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 30 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 30) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 84) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 138) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 192) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 246) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 300) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 30) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 32 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 32) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 86) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 140) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 194) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 248) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 302) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 32) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 34 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 34) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 88) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 142) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 196) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 250) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 304) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 34) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 36 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 36) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 90) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 144) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 198) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 252) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 306) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 36) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 38 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 38) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 92) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 146) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 200) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 254) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 308) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 38) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 40 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 40) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 94) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 148) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 202) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 256) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 310) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 40) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 42 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 42) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 96) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 150) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 204) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 258) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 312) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 42) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 44 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 44) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 98) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 152) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 206) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 260) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 314) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 44) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 46 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 46) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 100) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 154) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 208) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 262) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 316) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 46) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 48 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 48) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 102) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 156) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 210) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 264) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 318) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 48) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 50 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 50) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 104) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 158) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 212) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 266) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 320) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 50) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         /* K_Unrolling: 52 */
         A0 = (__m128d)_mm_load_ps( MMCAST(A0_off + 52) );
         A1 = (__m128d)_mm_load_ps( MMCAST(A0_off + 106) );
         A2 = (__m128d)_mm_load_ps( MMCAST(A0_off + 160) );
         A3 = (__m128d)_mm_load_ps( MMCAST(A0_off + 214) );
         A4 = (__m128d)_mm_load_ps( MMCAST(A0_off + 268) );
         A5 = (__m128d)_mm_load_ps( MMCAST(A0_off + 322) );
         
         B0 = (__m128d)_mm_load_ps( MMCAST(B0_off + 52) );
         A0 = _mm_mul_pd( B0, A0 );
         c0_0 = _mm_add_pd( A0, c0_0 );
         A1 = _mm_mul_pd( B0, A1 );
         c0_1 = _mm_add_pd( A1, c0_1 );
         A2 = _mm_mul_pd( B0, A2 );
         c0_2 = _mm_add_pd( A2, c0_2 );
         A3 = _mm_mul_pd( B0, A3 );
         c0_3 = _mm_add_pd( A3, c0_3 );
         A4 = _mm_mul_pd( B0, A4 );
         c0_4 = _mm_add_pd( A4, c0_4 );
         A5 = _mm_mul_pd( B0, A5 );
         c0_5 = _mm_add_pd( A5, c0_5 );
         prefetchABlock += 1*pfBlockDistance;
         /* Combine scalar expansion back to scalar */
         c0_0 = _mm_hadd_pd( c0_0, c0_1 );
         c0_2 = _mm_hadd_pd( c0_2, c0_3 );
         c0_4 = _mm_hadd_pd( c0_4, c0_5 );
         /* Applying Beta */
            /* Apply Beta Factor */
            /* Load C from memory */
            bc0_0 = _mm_loadu_pd( cPtrI0+0 );
            bc0_2 = _mm_loadu_pd( cPtrI0+2 );
            bc0_4 = _mm_loadu_pd( cPtrI0+4 );
            /* C = (beta*C) + (matrix multiply) */
            c0_0 = _mm_add_pd( bc0_0, c0_0 );
            c0_2 = _mm_add_pd( bc0_2, c0_2 );
            c0_4 = _mm_add_pd( bc0_4, c0_4 );
         /* Move pointers to next iteration */  
         A0_off += unroll_a;
         
         /* Store results back to memory  */
         _mm_storeu_ps( MMCAST( cPtrI0 ),  MMCASTStoreintrin( c0_0 ) );
         _mm_storeu_ps( MMCAST( cPtrI0+2 ),  MMCASTStoreintrin( c0_2 ) );
         _mm_storeu_ps( MMCAST( cPtrI0+4 ),  MMCASTStoreintrin( c0_4 ) );
         cPtrI0 += I_UNROLL;
         

      } /* End i/MB loop */

      B0_off += J_UNROLL*KB;
      cPtr += J_UNROLL*ldc_bytes;
   } /* End j/NB loop */
   /* End of generated inner loops */
}
#endif
