#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x67TN1x1x8_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=67, 
 * lda=67, ldb=67, ldc=0, mu=1, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (67*(Mb));
   const float *stN = B + (67*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 3, incAn = -(67*(Mb));
   #define incBk 8
   const int incBm = -64, incBn = 67;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < 8; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x67TN67x67x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=67, 
 * lda=67, ldb=67, ldc=0, mu=12, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (67*(Mb));
   const float *stN = B + (67*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*12*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 740, incAn = -(67*(Mb));
   #define incBk 8
   const int incBm = -64, incBn = 67;
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
            for (k=0; k < 8; k++) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[67];
               rA2 = pA0[134];
               rA3 = pA0[201];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[268];
               rA5 = pA0[335];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[402];
               rA7 = pA0[469];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[536];
               rA9 = pA0[603];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[670];
               rA11 = pA0[737];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[68];
               rA2 = pA0[135];
               rA3 = pA0[202];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[269];
               rA5 = pA0[336];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[403];
               rA7 = pA0[470];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[537];
               rA9 = pA0[604];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[671];
               rA11 = pA0[738];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[69];
               rA2 = pA0[136];
               rA3 = pA0[203];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[270];
               rA5 = pA0[337];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[404];
               rA7 = pA0[471];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[538];
               rA9 = pA0[605];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[672];
               rA11 = pA0[739];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[70];
               rA2 = pA0[137];
               rA3 = pA0[204];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[271];
               rA5 = pA0[338];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[405];
               rA7 = pA0[472];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[539];
               rA9 = pA0[606];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[673];
               rA11 = pA0[740];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[71];
               rA2 = pA0[138];
               rA3 = pA0[205];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[272];
               rA5 = pA0[339];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[406];
               rA7 = pA0[473];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[540];
               rA9 = pA0[607];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[674];
               rA11 = pA0[741];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[72];
               rA2 = pA0[139];
               rA3 = pA0[206];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[273];
               rA5 = pA0[340];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[407];
               rA7 = pA0[474];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[541];
               rA9 = pA0[608];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[675];
               rA11 = pA0[742];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[73];
               rA2 = pA0[140];
               rA3 = pA0[207];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[274];
               rA5 = pA0[341];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[408];
               rA7 = pA0[475];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[542];
               rA9 = pA0[609];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[676];
               rA11 = pA0[743];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[74];
               rA2 = pA0[141];
               rA3 = pA0[208];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[275];
               rA5 = pA0[342];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[409];
               rA7 = pA0[476];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[543];
               rA9 = pA0[610];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[677];
               rA11 = pA0[744];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[67];
            rA2 = pA0[134];
            rA3 = pA0[201];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[268];
            rA5 = pA0[335];
            rC1_0 += rA1 * rB0;
            rA6 = pA0[402];
            rA7 = pA0[469];
            rC2_0 += rA2 * rB0;
            rA8 = pA0[536];
            rA9 = pA0[603];
            rC3_0 += rA3 * rB0;
            rA10 = pA0[670];
            rA11 = pA0[737];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC11_0 += rA11 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[68];
            rA2 = pA0[135];
            rA3 = pA0[202];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[269];
            rA5 = pA0[336];
            rC1_0 += rA1 * rB0;
            rA6 = pA0[403];
            rA7 = pA0[470];
            rC2_0 += rA2 * rB0;
            rA8 = pA0[537];
            rA9 = pA0[604];
            rC3_0 += rA3 * rB0;
            rA10 = pA0[671];
            rA11 = pA0[738];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC11_0 += rA11 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[69];
            rA2 = pA0[136];
            rA3 = pA0[203];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[270];
            rA5 = pA0[337];
            rC1_0 += rA1 * rB0;
            rA6 = pA0[404];
            rA7 = pA0[471];
            rC2_0 += rA2 * rB0;
            rA8 = pA0[538];
            rA9 = pA0[605];
            rC3_0 += rA3 * rB0;
            rA10 = pA0[672];
            rA11 = pA0[739];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC11_0 += rA11 * rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x67TN1x1x8_a1_bX(k, N, 67, alpha, ca + (67*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
