#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0NN1x1x1_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const float *stM = A + (Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (Kb*lda), incAn = -(Mb);
   #define incBk 1
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < K; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0NN1x1x24_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/24)*24, kr = K - Kloop - 2;
   const float *stM = A + (Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (Kb*lda), incAn = -(Mb);
   #define incBk 24
   const int incBm = -(Kb), incBn = (ldb);
   #define incAk0 incAk
   const int incBk0 = ((incBk) / 24);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   if (K < 3)
   {
      ATL_sJIK0x0x0NN1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         rA0 = *pA0;
         rB0 = pB0[1];

         pB0 += (incBk0);
         for (k=0; k < Kloop; k += 24) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[21];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[22];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[23];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[24];
            pB0 += incBk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            pB0 += (incBk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            pB0 += (((incBk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            pB0 += (((incBk0) << 1)+incBk0);
            break;
         case 4:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            pB0 += (((incBk0) << 2));
            break;
         case 5:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            pB0 += (((incBk0) << 2)+incBk0);
            break;
         case 6:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            pB0 += (((incBk0) << 2)+((incBk0) << 1));
            break;
         case 7:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            pB0 += (7*(incBk0));
            break;
         case 8:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            pB0 += (((incBk0) << 3));
            break;
         case 9:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            pB0 += (((incBk0) << 3)+incBk0);
            break;
         case 10:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            pB0 += (((incBk0) << 3)+((incBk0) << 1));
            break;
         case 11:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            pB0 += (11*(incBk0));
            break;
         case 12:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            pB0 += (((incBk0) << 3)+((incBk0) << 2));
            break;
         case 13:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            pB0 += (13*(incBk0));
            break;
         case 14:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            pB0 += (14*(incBk0));
            break;
         case 15:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            pB0 += (15*(incBk0));
            break;
         case 16:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            pB0 += (((incBk0) << 4));
            break;
         case 17:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            pB0 += (((incBk0) << 4)+incBk0);
            break;
         case 18:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            pB0 += (((incBk0) << 4)+((incBk0) << 1));
            break;
         case 19:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[19];
            pB0 += (19*(incBk0));
            break;
         case 20:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[20];
            pB0 += (((incBk0) << 4)+((incBk0) << 2));
            break;
         case 21:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[21];
            pB0 += (21*(incBk0));
            break;
         case 22:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[21];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[22];
            pB0 += (22*(incBk0));
            break;
         case 23:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[21];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[22];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[23];
            pB0 += (23*(incBk0));
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         rC0_0 += m0;
         pB0 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x0NN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-1)/24)*24, kr = K - Kloop - 1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 4 - (Kb*lda), incAn = -(Mb);
   #define incBk 24
   const int incBm = -(Kb), incBn = (ldb);
   #define incAk0 incAk
   const int incBk0 = ((incBk) / 24);
   #define incCm 4
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            m1 = rA1 * rB0;
            rA3 = pA0[3];

            for (k=0; k < Kloop; k += 24) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[18];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[19];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[20];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[21];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[22];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[23];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[24];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 1)+incBk0);
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 2));
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 2)+incBk0);
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 2)+((incBk0) << 1));
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (7*(incBk0));
               break;
            case 8:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 3));
               break;
            case 9:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 3)+incBk0);
               break;
            case 10:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 3)+((incBk0) << 1));
               break;
            case 11:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (11*(incBk0));
               break;
            case 12:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 3)+((incBk0) << 2));
               break;
            case 13:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (13*(incBk0));
               break;
            case 14:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (14*(incBk0));
               break;
            case 15:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (15*(incBk0));
               break;
            case 16:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 4));
               break;
            case 17:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 4)+incBk0);
               break;
            case 18:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[18];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 4)+((incBk0) << 1));
               break;
            case 19:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[18];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[19];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (19*(incBk0));
               break;
            case 20:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[18];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[19];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[20];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (((incBk0) << 4)+((incBk0) << 2));
               break;
            case 21:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[18];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[19];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[20];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[21];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (21*(incBk0));
               break;
            case 22:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[18];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[19];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[20];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[21];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[22];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (22*(incBk0));
               break;
            case 23:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[3];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[5];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[7];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[9];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[10];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[11];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[12];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[13];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[14];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[15];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[16];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[17];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[18];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[19];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[20];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[21];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[22];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[23];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pB0 += (23*(incBk0));
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rC1_0 += m1;
            m1 = rA3 * rB0;
            pA0 += incAk0;
            rC2_0 += m0;
            rC3_0 += m1;
            pB0 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x0NN1x1x24_aX_bX(k, N, K, alpha, ca + (Mb), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
